# aDoctor
Code Smell Detector able to detect a set of 16 Android-specific design flaws.
The project is released under Apache 2.0 license. 

aDoctor is a project developed using Java able to identify design problems in Android apps.

For the moment, the tool supports the detection of the following code smells:

- Debuggable Release;
- Slow Loop;
- Data Transmission Without Compression;
- Inefficient Data Format and Parser;
- Inefficient Data Structure;
- Inefficient SQL Query;
- Internal Getter and Setter;
- Leaking Thread;
- Leaking Inner Class;
- Set Config Changes;
- No Low Memory Resolver;
- Unclosed Closable;
- Durable Wakelock;
- Member Ignoring Method;
- Public Data;
- Rigid Alarm Manager.

aDoctor is the outcome of the research conducted by the Software Engineering Lab of the University of Salerno, Italy.

To run the project, the unique parameter to specify consists of the folder where the Android applications are placed. 


